#!/usr/bin/scsh \
-e main -s
-*- scheme -*-
!#

(define local-guile-snapshot-incoming "/usr/local/src/Packages/guile-storage/snapshots")
(define guile-site		      "ftp.red-bean.com")
(define guile-snap-dir		      "/pub/guile/snapshots")
(define guile-modules		      '("core" "doc" "rgx-ctax" "scsh"))

(define (main . ignore-args)
  (with-cwd local-guile-snapshot-incoming
    (run (rm -f One-at-a-time-please))
    (for-each
     (lambda (tb)
       (format #t "Running `ncftp' to fetch `~A'...~%~%" tb)
       (if (> (run (ncftp -C ,(string-append guile-site ":" guile-snap-dir "/" tb)))
	      0)
	   (error (format #f "The ftp of `~A:~A/~A' failed" guile-site guile-snap-dir tb)))
       (& (begin
	    (call-with-current-continuation
	     (lambda (continue)
	       (let loop ()
		 (if (file-exists? "One-at-a-time-please")
		     (begin (sleep 5) (loop))
		     (continue)))))
	    (run (touch One-at-a-time-please))
	    (display "Untarring...") (newline)
	    (if (> (run (tar xzf ,tb))
		   0)
		(error (format #f "Failed to untar `~A'" tb)))
	    (let ((tb_base (substring tb 0 (rindex tb #\-))))
	      (with-cwd (string-append tb_base (format-date "-~Y~m~d" (date)))
		(display "Importing...")
		(newline)
		(if (> (run (cvs import
				 -ko
				 -m "Automatic import by `fetch-guile-snapshot-and-import'."
				 ,(string-append "debian/" tb_base)
				 source-dist
				 ,(format-date "upstream_version_~Y_~m_~d" (date))))
		       0)
		    (error (format #f "Failed to CVS import `~A'" tb)))))
	    (if (> (run (rm -rf ,tb)) 0)
		(error (format #f "Failed to rm the `~A' directory" tb)))
	    (run (rm One-at-a-time-please))
	    (run (rm ,tb))
	    (display "-----------------")
	    (newline)
	    (newline))))
     (map (lambda (s)
	    (string-append "guile-" s "-snap.tar.gz"))
	  guile-modules))))
